=== debian/changelog ===
robotraconteur-companion (0.4.2-1) unstable; urgency=medium

  * Initial release. (Closes: #1110150)

 -- John Wason <wason@wasontech.com>  Thu, 31 Jul 2025 22:13:13 +0000
