=== debian/control ===
Source: robotraconteur-companion
Section: libs
Priority: optional
Maintainer: John Wason <wason@wasontech.com>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-thread-dev,
               libboost-regex-dev,
               libboost-chrono-dev,
               libboost-atomic-dev,
               libboost-random-dev,
               libboost-program-options-dev,
               libboost-dev,
               libssl-dev,
               librobotraconteur-dev,
               libgtest-dev,
               libyaml-cpp-dev,
               libeigen3-dev,
               libopencv-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/johnwason/robotraconteur-companion
Vcs-Git: https://salsa.debian.org/johnwason/robotraconteur-companion.git
Homepage: https://github.com/robotraconteur/robotraconteur_companion

Package: librobotraconteurcompanion0.4
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Companion C++ library for Robot Raconteur runtime
 The Robot Raconteur C++ Companion library provides additional support
 for standardized types and services in Robot Raconteur along with
 other useful utilities. This package provides run-time library
 of robotraconteur-companion.

Package: librobotraconteur-companion-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: librobotraconteurcompanion0.4 (= ${binary:Version}),
         librobotraconteur-dev,
         ${misc:Depends},
         libboost-date-time-dev,
         libboost-filesystem-dev,
         libboost-thread-dev,
         libboost-regex-dev,
         libboost-chrono-dev,
         libboost-atomic-dev,
         libboost-random-dev,
         libboost-program-options-dev,
         libboost-dev,
         libyaml-cpp-dev,
         libeigen3-dev,
         libopencv-dev
Description: Companion C++ library for Robot Raconteur development files
 The Robot Raconteur C++ Companion library provides additional support
 for standardized types and services in Robot Raconteur along with
 other useful utilities. This package provides development files of
 robotraconteur-companion.
